/**
 * 
 */
package mmkurssit;

import java.io.OutputStream;
import java.io.PrintStream;

/**
 * - kopioi CRC-kortin vastuut tähän
 * @author aichi
 * @version 25 Feb 2025
 *
 */
public class Kurssi {

    private int kurssiID = 0;
    private String nimi = "";
    private String opeSukunimi = "";
    private String opeEtunimi = "";
    
    private static int nextID = 1; // static = riippumatta olion olemassa olosta, atribuutti syntyy
                                        //          kun ohjelma käynistyy
                                        //        = yhteinen attribuutti koko luokassa
//=========================================================    
    
    /**
     * Kurssin alustuts
     */
    public Kurssi() {
        //
    }
    
    
    /**
     * Tulostetaan kurssin tiedot
     * @param os teitovirta johon tulostetaan 
     */
    public void tulosta(OutputStream os) {
        //tulsota(new PrintStream(os));
    }
    
    
    /**
     * Tulostetaan kurssin teidot
     * @param out tietovirta johon tulostetaan
     */
    public void tulosta(PrintStream out) {
        out.println(String.format("Course ID: %03d", kurssiID) + " " + nimi);
                        //"%03d" = aina vähintään 3 numeroa, jos se ei täytä 3 numeroa niin 0:lla täytä
                        // sama tulostuu ("Course ID: ") + String.format("%03d", kurssiID)+ ---
        out.println(" Teacher: " + opeEtunimi + " " + opeSukunimi);
    }
    
    
    /**
     * Palauttaa kurssin tunnusnumeron.
     * @return kurssin tunnusnumero
     */
    public int getID() {
        return this.kurssiID;
    }
    
    /**
     * Antaa kurssille seuraavan tunnusnumeron
     * @example
     * <pre name="test">
     *    Kurssi saksa = new Kurssi();
     *      saksa.getID() === 0;
     *      saksa.rekisteroi();
     *    Kurssi ohjelmointi = new Kurssi();
     *      ohjelmointi.rekisteroi();
     *    int n1 = saksa.getID();
     *    int n2 = ohjelmointi.getID();
     *    n1 === 1;
     *    n2 === 2;
     * </pre>
     */
    public void rekisteroi() {
        this.kurssiID = nextID;
        nextID++;
    }
    
    
    //MAIN========================================================
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
    // luento 24.2.2025
    // Käytetään fxMMKurssi-mainissa oleva main koko ohjelmaa varten, mutta Java sallii,
    //että ohjelman sisällä tavallaan monta main-methodia.
        Kurssi japani4 = new Kurssi();
        Kurssi ohjelmointi2 = new Kurssi();
        
        japani4.rekisteroi();
        ohjelmointi2.rekisteroi();
        
        japani4.tulosta(System.out);
        ohjelmointi2.tulosta(System.out);
        System.out.println(nextID);
        
        //japani4.tayta();
        //ohjelmointi2.tayta();
        
        japani4.tulosta(System.out);
        ohjelmointi2.tulosta(System.out);
    }

    
    /**
     * 
     * 
     */
    private void tayta() {
        // TODO Auto-generated method stub
        
    }


    

}
